Name:           uxn
Version:        1.0
Release:        %{autorelease}
Summary:        Uxn emulator

License:        MIT
URL:            https://git.sr.ht/~rabbits/uxn
Source0:        %{url}/archive/%{version}.tar.gz#/uxn-%{version}.tar.gz
Source1:        https://wiki.xxiivv.com/media/identity/uxn64.png#/uxnemu.png
Source2:        uxnemu.desktop
Source3:        uxnemu.metainfo.xml

BuildRequires:  binutils-devel
BuildRequires:  gcc
BuildRequires:  SDL2-devel
# GUI files
BuildRequires:  desktop-file-utils
BuildRequires:  libappstream-glib

%description
An assembler and emulator for the Uxn stack-machine, written in ANSI C.

%prep
%autosetup
sed -i 's|#include <SDL.h>|#include <SDL2/SDL.h>|g' src/uxnemu.c

%build

mkdir bin

${CC} ${CFLAGS} src/uxnasm.c -o bin/uxnasm
${CC} ${CFLAGS} src/uxn.c src/devices/system.c src/devices/console.c \
                src/devices/file.c src/devices/datetime.c src/devices/mouse.c \
                src/devices/controller.c src/devices/screen.c \
                src/devices/audio.c src/uxnemu.c \
                -L%{_libdir} $(sdl2-config --cflags --libs) \
                -L%{_libdir} -liberty  -o bin/uxnemu
${CC} ${CFLAGS} src/uxn.c src/devices/system.c src/devices/console.c \
                src/devices/file.c src/devices/datetime.c src/uxncli.c \
                -L%{_libdir} -liberty -o bin/uxncli


%install
mkdir -p %{buildroot}%{_bindir}
install -m755 bin/uxnasm %{buildroot}%{_bindir}
install -m755 bin/uxnemu %{buildroot}%{_bindir}
install -m755 bin/uxncli %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_datadir}/pixmaps
install -m644 %{SOURCE1} %{buildroot}%{_datadir}/pixmaps/
desktop-file-install                                    \
--dir=%{buildroot}%{_datadir}/applications %{SOURCE2}
mkdir -p %{buildroot}%{_metainfodir}
install -m644 %{SOURCE3} %{buildroot}%{_metainfodir}
mkdir -p %{buildroot}%{_exec_prefix}/lib/uxn
install -m644 projects/library/*.tal \
 %{buildroot}%{_exec_prefix}/lib/uxn
install -dm644 projects/assets %{buildroot}%{_datadir}/uxn
install -dm644 projects/fonts %{buildroot}%{_datadir}/uxn
install -dm644 projects/pictures %{buildroot}%{_datadir}/uxn
install -dm644 projects/software %{buildroot}%{_datadir}/uxn
install -dm644 projects/sounds %{buildroot}%{_datadir}/uxn
install -dm644 projects/utils %{buildroot}%{_datadir}/uxn

%check
# Test usage
./bin/uxnasm
./bin/uxncli
./bin/uxnemu

# Test version
./bin/uxnasm -v
./bin/uxncli -v
./bin/uxnemu -v
appstream-util validate-relax --nonet \
  %{buildroot}%{_metainfodir}/uxnemu.metainfo.xml

%files
%license LICENSE
%doc README.md
%{_bindir}/uxnasm
%{_bindir}/uxnemu
%{_bindir}/uxncli
%{_exec_prefix}/lib/uxn/
%{_datadir}/uxn/
%doc projects/examples
%{_metainfodir}/uxnemu.metainfo.xml
%{_datadir}/applications/uxnemu.desktop
%{_datadir}/pixmaps/uxnemu.png

%changelog
%autochangelog
